"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  EVENT_NAMES: () => EVENT_NAMES,
  FIELD_QUERY_PARAMS: () => FIELD_QUERY_PARAMS,
  FieldTypes: () => FieldTypes,
  RpcChannel: () => RpcChannel,
  registerCustomTool: () => registerCustomTool,
  registerToolIcons: () => registerToolIcons
});
module.exports = __toCommonJS(src_exports);

// src/rte/functions.ts
function registerCustomTool(toolName, fn) {
  ensureSfNamespace((globalObject) => {
    globalObject.sf.rteTools[toolName] = fn;
  });
}
function registerToolIcons(callback) {
  ensureSfNamespace((globalObject) => {
    globalObject.sf.rteToolsIconsSetupCallback = callback;
  });
}
function ensureSfNamespace(fn) {
  const globalObject = typeof window !== "undefined" ? window : global;
  globalObject.sf = globalObject.sf || {};
  globalObject.sf.rteTools = window.sf.rteTools || {};
  globalObject.sf.rteToolsIconsSetupCallback = window.sf.rteToolsIconsSetupCallback || null;
  fn(globalObject);
}

// ../../src/app/modules/shared/fields-builder/services/field-types.ts
var FieldTypes = Object.freeze({
  media: "sf-media",
  // for related media
  mediaData: "sf-media-data",
  // for the content of a media item
  shortText: "sf-short-text",
  password: "sf-password-short-text",
  shortTextDefault: "sf-short-text-default",
  longText: "sf-long-text",
  html: "sf-wrapper-html",
  taxa: "sf-taxa",
  facetTaxa: "sf-facet-taxa",
  urlName: "sf-url-name",
  number: "sf-number",
  additionalUrls: "sf-additional-urls",
  choice: "sf-choice",
  taxonomyTypeChoice: "sf-choice-taxonomy-type",
  choiceReadonly: "sf-choice-readOnly",
  choiceDropDown: "sf-dropdown-choice",
  choiceDropDownList: "sf-dropdown-list-choice",
  choiceMultiple: "sf-multiple-choice",
  choiceMultipleReadonly: "sf-multiple-choice-readonly",
  choiceYesNo: "sf-yes-no-choice",
  choiceYesNoReadonly: "sf-yes-no-choice-readOnly",
  choiceList: "sf-choice-list",
  choiceListMultiple: "sf-choice-list-multiple",
  choiceParameterizedSelector: "sf-parameterized-choice-selector",
  choiceChip: "sf-chip-choice",
  choiceServiceUrl: "sf-choice-service-url",
  switch: "sf-switch-wrapper",
  dateTime: "sf-date-time",
  date: "sf-date-time",
  relatedData: "sf-related-data",
  dropdownSelector: "sf-dropdown-selector",
  textArea: "sf-text-area",
  linkInsert: "sf-link-insert",
  address: "sf-address",
  recurringEvent: "sf-recurring-event",
  timezones: "sf-timezones",
  parentDropdownSelector: "sf-parent-dropdown-selector",
  eventTimeCompositeField: "sf-event-time-composite-field",
  color: "sf-color-picker",
  hidden: "sf-hidden",
  siteSync: "sf-site-sync-item-info",
  navigationOptionsCompositeField: "sf-navigation-options-composite-field",
  localizationStrategy: "sf-localization-selector",
  searchSiteCompositeField: "sf-search-site-composite-field",
  advancedOptionsCompositeField: "sf-advanced-optins",
  arrayOfGUIDs: "sf-array-of-guids",
  urlNameStructure: "sf-url-name-structure",
  read: "sf-read-only",
  titleRead: "sf-title-read-only",
  complex: "sf-complex",
  multipleChoiceChip: "sf-multiple-choice-chip",
  customSize: "sf-edit-image-thumbnail",
  thumbnail: "sf-thumbnail-selector",
  fileList: "sf-file-list",
  content: "sf-content-selector",
  contentAll: "sf-filtercontent-selector",
  videoThumbnail: "sf-video-thumbnail",
  itemList: "sf-item-list",
  templateThumbnail: "sf-template-thumbnail",
  listSettings: "sf-list-settings",
  resultsListSettings: "sf-extended-list-settings",
  listFieldMapping: "sf-field-mappings",
  listFieldMappingCss: "sf-field-mappings-css",
  viewSelector: "sf-view-selector",
  range: "sf-range",
  rangeLimitation: "sf-range-limitation",
  attributes: "sf-attributes",
  fileTypes: "sf-file-types",
  pencilButton: "sf-pencil-button",
  taxonSelector: "sf-taxon-selector",
  contentTypeSelector: "sf-content-type-selector",
  dateAndTimeSelector: "sf-date-and-time-selector",
  formRedirectPageCompositeField: "sf-form-redirect-page-composite-field",
  linkSelector: "sf-link-selector",
  fieldSelector: "sf-field-selector",
  navigateToUrl: "sf-navigate-to-url",
  statusSelector: "sf-status-selector",
  dateTimeSelectorContent: "sf-datetime-selector-content",
  aiTaxa: "sf-taxa-ai",
  dropdownWithText: "sf-dropdown-with-text",
  iframeField: "sf-iframe-field"
});

// src/custom-fields/interfaces.ts
var EVENT_NAMES = {
  /** Event name for initialization. */
  INIT: "SF_INIT"
};
var FIELD_QUERY_PARAMS = {
  /** Query parameter for the field name. */
  FIELD_NAME: "fieldName",
  /** Query parameter for the field type. */
  FIELD_TYPE: "fieldType",
  /** Query parameter for the type name. */
  TYPE_NAME: "typeName",
  /** Query parameter for the field origin. */
  ORIGIN: "sf-origin"
};

// src/rpc/rpc-channel.ts
var import_rxjs = require("rxjs");
var RpcChannel = class {
  constructor(targetWindow, targetOrigin) {
    this.services = /* @__PURE__ */ new Map();
    this.pendingRequests = /* @__PURE__ */ new Map();
    this.eventHandlers = /* @__PURE__ */ new Map();
    this.messageSubject = new import_rxjs.Subject();
    this.targetWindow = targetWindow;
    this.targetOrigin = targetOrigin;
    window.addEventListener("message", (event) => this.messageSubject.next(event));
    this.messageSubject.pipe((0, import_rxjs.filter)((event) => this.isValidEvent(event))).subscribe((event) => this.onMessage(event));
  }
  // Security check for incoming messages
  isValidEvent(event) {
    return event.source === this.targetWindow && event.origin === this.targetOrigin;
  }
  onMessage(event) {
    if (!this.isValidEvent(event))
      return;
    const message = event.data;
    if (message.type === "rpc_response") {
      const { id, result, error } = message;
      const pending = this.pendingRequests.get(id);
      if (pending) {
        if (error) {
          pending.reject(error);
        } else {
          pending.resolve(result);
        }
        this.pendingRequests.delete(id);
      }
    } else if (message.type === "rpc_request") {
      const { id, method, params } = message;
      const [serviceName, methodName] = method.split(".");
      const serviceEntry = this.services.get(serviceName);
      if (serviceEntry && serviceEntry.methods.has(methodName)) {
        const { instance } = serviceEntry;
        if (typeof instance[methodName] === "function") {
          Promise.resolve(instance[methodName].apply(instance, params)).then((result) => {
            const response = { type: "rpc_response", id, result };
            this.targetWindow.postMessage(response, this.targetOrigin);
          }).catch((error) => {
            const response = {
              type: "rpc_response",
              id,
              error: error.message || error
            };
            this.targetWindow.postMessage(response, this.targetOrigin);
          });
        } else {
          const response = {
            type: "rpc_response",
            id,
            error: `Method '${methodName}' is not a function`
          };
          this.targetWindow.postMessage(response, this.targetOrigin);
        }
      } else {
        const response = {
          type: "rpc_response",
          id,
          error: `Service '${serviceName}' or method '${methodName}' not found`
        };
        this.targetWindow.postMessage(response, this.targetOrigin);
      }
    } else if (message.type === "event") {
      const { eventName, payload } = message;
      const handlers = this.eventHandlers.get(eventName);
      if (handlers) {
        handlers.forEach((handler) => handler(payload));
      }
    }
  }
  /**
   * Calls a remote method and returns a Promise with the result.
   * @param method The name of the remote method to call (e.g., "ServiceName.methodName").
   * @param params Parameters to pass to the remote method.
   */
  call(method, ...params) {
    const id = this.generateUniqueId();
    const request = { type: "rpc_request", id, method, params };
    return new Promise((resolve, reject) => {
      this.pendingRequests.set(id, { resolve, reject });
      this.targetWindow.postMessage(request, this.targetOrigin);
    });
  }
  /**
   * Creates a proxy object to call methods on the remote service.
   * @param serviceName The name of the remote service.
   * @param methods An array of method names to expose.
   */
  getService(serviceName, methods) {
    const handler = {
      get: (_target, propKey) => {
        if (!methods.includes(propKey)) {
          throw new Error(
            `Method '${propKey}' is not exposed on service '${serviceName}'`
          );
        }
        return (...args) => {
          const methodName = `${serviceName}.${propKey}`;
          return this.call(methodName, ...args);
        };
      }
    };
    return new Proxy({}, handler);
  }
  /**
   * Emits an event to the remote side.
   * @param eventName The name of the event.
   * @param payload The data to send with the event.
   */
  emit(eventName, payload) {
    const event = { type: "event", eventName, payload };
    this.targetWindow.postMessage(event, this.targetOrigin);
  }
  /**
   * Subscribes to an event emitted by the remote side.
   * @param eventName The name of the event.
   * @param handler The function to execute when the event is received.
   */
  on(eventName, handler) {
    if (!this.eventHandlers.has(eventName)) {
      this.eventHandlers.set(eventName, []);
    }
    this.eventHandlers.get(eventName).push(handler);
  }
  /**
   * Unsubscribes from a previously subscribed event.
   * @param eventName The name of the event.
   * @param handler The handler function to remove.
   */
  off(eventName, handler) {
    const handlers = this.eventHandlers.get(eventName);
    if (handlers) {
      this.eventHandlers.set(
        eventName,
        handlers.filter((h) => h !== handler)
      );
    }
  }
  // Generates a unique ID for RPC requests
  generateUniqueId() {
    return Math.random().toString(36).substr(2, 9);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  EVENT_NAMES,
  FIELD_QUERY_PARAMS,
  FieldTypes,
  RpcChannel,
  registerCustomTool,
  registerToolIcons
});
//# sourceMappingURL=index.js.map
