/**
 * Interface representing the data structure for a field.
 */
export interface FieldData {
    /** The initial value of the field. */
    initialValue: any;
    /** The settings associated with the field. */
    settings: any;
}
/**
 * An object containing event name constants used for communication with Sitefinity.
 */
export declare const EVENT_NAMES: {
    /** Event name for initialization. */
    INIT: string;
};
/**
 * An object containing query parameter names used in field URLs.
 */
export declare const FIELD_QUERY_PARAMS: {
    /** Query parameter for the field name. */
    FIELD_NAME: string;
    /** Query parameter for the field type. */
    FIELD_TYPE: string;
    /** Query parameter for the type name. */
    TYPE_NAME: string;
    /** Query parameter for the field origin. */
    ORIGIN: string;
};
/**
 * FieldTypes enum from the fields registry module.
 */
export { FieldTypes } from "../../../../src/app/modules/shared/fields-builder/services/field-types";
