export interface RpcRequest {
    type: "rpc_request";
    id: string;
    method: string;
    params: any[];
}
export interface RpcResponse {
    type: "rpc_response";
    id: string;
    result?: any;
    error?: any;
}
export interface RpcEvent {
    type: "event";
    eventName: string;
    payload: any;
}
export type RpcMessage = RpcRequest | RpcResponse | RpcEvent;
export type MethodNames<T> = {
    [K in keyof T]: T[K] extends Function ? K : never;
}[keyof T];
